'use strict';

const mapValues = require('lodash/mapValues');
const redisKey = require('../utils/key.js');
const Promise = require('bluebird');
var _Array = Array;
const isArray = _Array.isArray;

const JSONParse = JSON.parse.bind(JSON);

var _require = require('../constants.js');

const USERS_METADATA = _require.USERS_METADATA;


module.exports = function getMetadata(username, _audience) {
  const redis = this.redis;

  const audience = isArray(_audience) ? _audience : [_audience];

  return Promise.map(audience, function getAudienceData(aud) {
    return redis.hgetallBuffer(redisKey(username, USERS_METADATA, aud));
  }).then(function remapAudienceData(data) {
    const output = {};
    audience.forEach(function transform(aud, idx) {
      const datum = data[idx];
      if (datum) {
        output[aud] = mapValues(datum, JSONParse);
      } else {
        output[aud] = {};
      }
    });

    return output;
  });
};