'use strict';

const Promise = require('bluebird');
const Errors = require('common-errors');

var _require = require('../constants.js');

const USERS_ACTIVE_FLAG = _require.USERS_ACTIVE_FLAG;


module.exports = function isBanned(data) {
  if (String(data[USERS_ACTIVE_FLAG]) !== 'true') {
    return Promise.reject(new Errors.HttpStatusError(412, 'Account hasn\'t been activated'));
  }

  return Promise.resolve(data);
};