'use strict';

const Promise = require('bluebird');
const Errors = require('common-errors');

var _require = require('../constants.js');

const USERS_BANNED_FLAG = _require.USERS_BANNED_FLAG;


module.exports = function isBanned(data) {
  if (String(data[USERS_BANNED_FLAG]) === 'true') {
    return Promise.reject(new Errors.HttpStatusError(423, 'Account has been locked'));
  }

  return Promise.resolve(data);
};